Antiprism 0.23

- Main Page
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions

# scene_geom Class Reference

Class for a geometry in a scene. More...

`#include <scene.h>`

Inheritance diagram for scene_geom:
[legend]
Collaboration diagram for scene_geom:
[legend]

List of all members.

## Public Member Functions
| scene_geom (const geom_if &geo=col_geom_v())
| Constructor.
| scene_geom (const scene_geom &sc_geo)
| Copy constructor.
scene_geom & | operator= (const scene_geom &sc_geo)
| Assignment operator.
| ~scene_geom ()
| Destructor.
void | set_geom (const geom_if &geo=col_geom_v())
| Set the geometry.
const geom_if & | get_geom () const
| Get the geometry.
col_geom_v & | get_geom ()
| Get the geometry.
void | geom_changed ()
| Indicate that the geometry has changed.
double | get_v_ball_rad () const
| Get the vertex ball radius (the maximum without overlap.)
double | min_rad () const
| Get the minimum display radius.
const bound_sphere & | get_bound_sph () const
| Get a sphere that bounds the geometry.
void | set_width (double wdth)
| Set the width of the geometry.
double | get_width () const
| Get the width of the geometry.
void | set_centre (vec3d cent)
| Set the centre of the geometry.
vec3d | get_centre () const
| Get the centre of the geometry.
void | add_disp (geom_disp &disp)
| Add a new display.
bool | delete_disp (int idx)
| Delete a display.
const vector< geom_disp * > & | get_disps () const
| Get the displays.
vector< geom_disp * > & | get_disps ()
| Get the displays.
geom_disp_label * | get_label () const
| Get the geometry label display.
void | set_label (const geom_disp_label &lab)
| Set the geometry label display.
vec3d | get_v_label_pos (int idx) const
| Position of a vertex label.
vec3d | get_e_label_pos (int idx) const
| Position of an edge label.
vec3d | get_f_label_pos (int idx) const
| Position of a face label.
geom_disp * | get_sym () const
| Get the symmetry element display.
void | set_sym (const geom_disp &sym)
| Set the symmetry element display.
int | animate ()
| Update animated displays.

## Detailed Description

Class for a geometry in a scene.

## Constructor & Destructor Documentation

scene_geom::scene_geom | ( | const geom_if & | geo = `col_geom_v()` | ) |

Constructor.

Parameters:

  geo | the geometry to display in a scene.

scene_geom::scene_geom | ( | const scene_geom & | sc_geo | ) |

Copy constructor.

Parameters:

  sc_geo | the scene geometry to copy from.

## Member Function Documentation

void scene_geom::add_disp | ( | geom_disp & | disp | ) |

Add a new display.

Parameters:

  disp | display to add.

int scene_geom::animate | ( |  | ) |

Update animated displays.

Returns:
  The number of animation changes (`0` if no changes).

bool scene_geom::delete_disp | ( | int | idx | ) |

Delete a display.

Parameters:

  idx | index number of the display to delete.

void scene_geom::geom_changed | ( |  | ) |

Indicate that the geometry has changed.

Call this if the disply geometry has been changed through a reference to the data member.

const bound_sphere& scene_geom::get_bound_sph | ( |  | ) | const`[inline]`

Get a sphere that bounds the geometry.

Returns:
  A sphere that bonds the geometry.

vec3d scene_geom::get_centre | ( |  | ) | const`[inline]`

Get the centre of the geometry.

Returns:
  The centre of the geometry.

vector<geom_disp *>& scene_geom::get_disps | ( |  | ) | `[inline]`

Get the displays.

Returns:
  The vector of displays.

const vector<geom_disp *>& scene_geom::get_disps | ( |  | ) | const`[inline]`

Get the displays.

Returns:
  The vector of displays.

vec3d scene_geom::get_e_label_pos | ( | int | idx | ) | const

Position of an edge label.

Parameters:

  idx | edge index number.

Returns:
  position of the label

vec3d scene_geom::get_f_label_pos | ( | int | idx | ) | const

Position of a face label.

Parameters:

  idx | face index number.

Returns:
  position of the label

col_geom_v& scene_geom::get_geom | ( |  | ) | `[inline]`

Get the geometry.

Returns:
  the geometry to display.

const geom_if& scene_geom::get_geom | ( |  | ) | const`[inline]`

Get the geometry.

Returns:
  the geometry to display.

geom_disp_label * scene_geom::get_label | ( |  | ) | const

Get the geometry label display.

Returns:
  The geometry label display.

geom_disp * scene_geom::get_sym | ( |  | ) | const

Get the symmetry element display.

Returns:
  The symmetry element display.

double scene_geom::get_v_ball_rad | ( |  | ) | const`[inline]`

Get the vertex ball radius (the maximum without overlap.)

Returns:
  The vertex ball radius.

vec3d scene_geom::get_v_label_pos | ( | int | idx | ) | const

Position of a vertex label.

Parameters:

  idx | vertex index number.

Returns:
  position of the label

double scene_geom::get_width | ( |  | ) | const`[inline]`

Get the width of the geometry.

Returns:
  The width of the geometry

double scene_geom::min_rad | ( |  | ) | const`[inline]`

Get the minimum display radius.

Returns:
  The minimum radius.

scene_geom & scene_geom::operator= | ( | const scene_geom & | sc_geo | ) |

Assignment operator.

Parameters:

  sc_geo | the scene geometry to assign from.

void scene_geom::set_centre | ( | vec3d | cent | ) | `[inline]`

Set the centre of the geometry.

Parameters:

  cent | the centre to set

void scene_geom::set_geom | ( | const geom_if & | geo = `col_geom_v()` | ) |

Set the geometry.

Parameters:

  geo | the geometry to display.

void scene_geom::set_label | ( | const geom_disp_label & | lab | ) |

Set the geometry label display.

Parameters:

  lab | the geometry label display to set.

void scene_geom::set_sym | ( | const geom_disp & | sym | ) |

Set the symmetry element display.

Parameters:

  sym | the symmetry element display to set.

void scene_geom::set_width | ( | double | wdth | ) | `[inline]`

Set the width of the geometry.

Parameters:

  wdth | the width to set

The documentation for this class was generated from the following files:

- base/scene.h
- base/scene.cc